The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::BiQuad Class Reference

STK biquad (two-pole, two-zero) filter class. More...

`#include <BiQuad.h>`

Inheritance diagram for stk::BiQuad:

List of all members.

## Public Member Functions
| BiQuad ()
| Default constructor creates a second-order pass-through filter.
| ~BiQuad ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat b2, StkFloat a1, StkFloat a2, bool clearState=false)
| Set all filter coefficients.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setB2 (StkFloat b2)
| Set the b[2] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setA2 (StkFloat a2)
| Set the a[2] coefficient value.
void | setResonance (StkFloat frequency, StkFloat radius, bool normalize=false)
| Sets the filter coefficients for a resonance at frequency (in Hz).
void | setNotch (StkFloat frequency, StkFloat radius)
| Set the filter coefficients for a notch at frequency (in Hz).
void | setEqualGainZeroes (void)
| Sets the filter zeroes for equal resonance gain.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return a reference to one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK biquad (two-pole, two-zero) filter class.

This class implements a two-pole, two-zero digital filter. Methods are provided for creating a resonance or notch in the frequency response while maintaining a constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::BiQuad::setResonance | ( | StkFloat | frequency,
|  | StkFloat | radius,
|  | bool | normalize = `false` |
| ) |  |  |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the filter zeros are placed at z = 1, z = -1, and the coefficients are then normalized to produce a constant unity peak gain (independent of the filter gain parameter). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. The frequency value should be between zero and half the sample rate.

void stk::BiQuad::setNotch | ( | StkFloat | frequency,
|  | StkFloat | radius |
| ) |  |  |

Set the filter coefficients for a notch at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. No filter normalization is attempted. The frequency value should be between zero and half the sample rate. The radius value should be positive.

void stk::BiQuad::setEqualGainZeroes | ( | void |  | ) |

Sets the filter zeroes for equal resonance gain.

When using the filter as a resonator, zeroes places at z = 1, z = -1 will result in a constant gain at resonance of 1 / (1 - R), where R is the pole radius setting.

StkFrames & stk::BiQuad::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00133 {
    00134 #if defined(_STK_DEBUG_)
    00135   if ( channel >= frames.channels() ) {
    00136     oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
    00137     handleError( StkError::FUNCTION_ARGUMENT );
    00138   }
    00139 #endif
    00140
    00141   StkFloat *samples = &frames[channel];
    00142   unsigned int hop = frames.channels();
    00143   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00144     inputs_[0] = gain_ * *samples;
    00145     *samples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
    00146     *samples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
    00147     inputs_[2] = inputs_[1];
    00148     inputs_[1] = inputs_[0];
    00149     outputs_[2] = outputs_[1];
    00150     outputs_[1] = *samples;
    00151   }
    00152
    00153   lastFrame_[0] = outputs_[1];
    00154   return frames;
    00155 }

StkFrames & stk::BiQuad::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00158 {
    00159 #if defined(_STK_DEBUG_)
    00160   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00161     oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
    00162     handleError( StkError::FUNCTION_ARGUMENT );
    00163   }
    00164 #endif
    00165
    00166   StkFloat *iSamples = &iFrames[iChannel];
    00167   StkFloat *oSamples = &oFrames[oChannel];
    00168   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00169   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00170     inputs_[0] = gain_ * *iSamples;
    00171     *oSamples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
    00172     *oSamples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
    00173     inputs_[2] = inputs_[1];
    00174     inputs_[1] = inputs_[0];
    00175     outputs_[2] = outputs_[1];
    00176     outputs_[1] = *oSamples;
    00177   }
    00178
    00179   lastFrame_[0] = outputs_[1];
    00180   return iFrames;
    00181 }

The documentation for this class was generated from the following file:

- BiQuad.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.